From b48cd074345673694c4b8bf3a6ad496760ea562c Mon Sep 17 00:00:00 2001
From: "yeping.zheng" <yeping.zheng@nio.com>
Date: Mon, 29 Jul 2024 09:27:16 +0800
Subject: [PATCH] Subject: [PATCH] A segfault issue due to the incorrect irq_stack_size on ARM64

See the following stack trace:
(gdb) bt
 #0  0x00005635ac2b166b in arm64_unwind_frame (frame=0x7ffdaf35cb70, bt=0x7ffdaf35d430) at arm64.c:2821
 #1  arm64_back_trace_cmd (bt=0x7ffdaf35d430) at arm64.c:3306
 #2  0x00005635ac27b108 in back_trace (bt=bt@entry=0x7ffdaf35d430) at kernel.c:3239
 #3  0x00005635ac2880ae in cmd_bt () at kernel.c:2863
 #4  0x00005635ac1f16dc in exec_command () at main.c:893
 #5  0x00005635ac1f192a in main_loop () at main.c:840
 #6  0x00005635ac50df81 in captured_main (data=<optimized out>) at main.c:1284
 #7  gdb_main (args=<optimized out>) at main.c:1313
 #8  0x00005635ac50e000 in gdb_main_entry (argc=<optimized out>, argv=<optimized out>) at main.c:1338
 #9  0x00005635ac1ea2a5 in main (argc=5, argv=0x7ffdaf35dde8) at main.c:721

The issue may be encountered when thread_union symbol not found in vmlinux
due to compiling optimization.

This patch will try the following 2 methods to get the irq_stack_size
when thread_union symbol unavailable:

1. Try getting the value from IKconfig.
2. Try getting the value from kernel code disassembly, to get
   THREAD_SHIFT directly from tbnz instruction.

In arch/arm64/kernel/entry.S:

.macro kernel_ventry, el:req, ht:req, regsize:req, label:req
...
        add     sp, sp, x0
        sub     x0, sp, x0
        tbnz    x0, #THREAD_SHIFT, 0f

$ gdb vmlinux
(gdb) disass vectors
Dump of assembler code for function vectors:
   ...
   0xffff800080010804 <+4>:     add     sp, sp, x0
   0xffff800080010808 <+8>:     sub     x0, sp, x0
   0xffff80008001080c <+12>:    tbnz    w0, #16, 0xffff80008001081c <vectors+28>

Signed-off-by: yeping.zheng <yeping.zheng(a)nio.com&gt;
---
 arm64.c | 59 ++++++++++++++++++++++++++++++++++++++++++++++++++++++---
 1 file changed, 56 insertions(+), 3 deletions(-)

diff --git a/arm64.c b/arm64.c
index 78e6609..26f4153 100644
--- a/arm64.c
+++ b/arm64.c
@@ -94,6 +94,7 @@ static int arm64_is_uvaddr(ulong, struct task_context *);
 static void arm64_calc_KERNELPACMASK(void);
 static void arm64_recalc_KERNELPACMASK(void);
 static int arm64_get_vmcoreinfo(unsigned long *vaddr, const char *label, int base);
+static ulong arm64_set_irq_stack_size(void);
 
 struct kernel_range {
 	unsigned long modules_vaddr, modules_end;
@@ -2234,8 +2235,10 @@ arm64_irq_stack_init(void)
 		if (MEMBER_EXISTS("thread_union", "stack")) { 
 			if ((sz = MEMBER_SIZE("thread_union", "stack")) > 0)
 				ms->irq_stack_size = sz;
-		} else
-			ms->irq_stack_size = ARM64_IRQ_STACK_SIZE;
+		} else {
+			ulong res = arm64_set_irq_stack_size();
+			ms->irq_stack_size = (res > 0) ? res : ARM64_IRQ_STACK_SIZE;
+		}
 
 		machdep->flags |= IRQ_STACKS;
 
@@ -4950,6 +4953,56 @@ static void arm64_recalc_KERNELPACMASK(void){
 	}
 }
 
-#endif  /* ARM64 */
+static ulong arm64_set_irq_stack_size(void)
+{
+	char *string;
+	int min_thread_shift = 14;
+	ulong thread_shift = 0;
 
+	char buf1[BUFSIZE];
+	char *pos1, *pos2;
+	int errflag = 0;
+
+	if (kernel_symbol_exists("kasan_enable_current")) {
+		min_thread_shift += 1;
+		thread_shift = (min_thread_shift < machdep->pageshift) ? machdep->pageshift : min_thread_shift;
+	} else {
+		sprintf(buf1, "x/32i vectors");
+		open_tmpfile();
+		if (!gdb_pass_through(buf1, pc->tmpfile, GNU_RETURN_ON_ERROR)) {
+			goto out;
+		}
+		rewind(pc->tmpfile);
+		while (fgets(buf1, BUFSIZE, pc->tmpfile)) {
+			if ((pos1 = strstr(buf1, "tbnz"))) {
+				if ((pos2 = strchr(pos1, '#'))) {
+					pos2 += 1;
+					pos1 = pos2;
+					while (*pos2 != '\0') {
+						if (!((*pos2 >= '0' && *pos2 <= '9')
+							|| (*pos2 >= 'A' && *pos2 <= 'F')
+							|| (*pos2 >= 'a' && *pos2 <= 'f'))) {
+							*pos2 = '\0';
+							break;
+						}
+						++pos2;
+					}
+					thread_shift = stol(pos1, RETURN_ON_ERROR|QUIET, &errflag);
+					if (errflag) {
+						thread_shift = 0;
+					}
+					break;
+				}
+			}
+		}
+out:
+		close_tmpfile();
+	}
+
+	if (!thread_shift)
+		return 0;
+	else
+		return ((1UL) << thread_shift);
+}
 
+#endif  /* ARM64 */
\ No newline at end of file
-- 
2.25.1